package SearchEngine ;

import java.io.InputStream;
import java.util.List;

public interface Indexer 
{
	/**
     * This should add the given document to the inverted index
     */
	void addDocument(InputStream stream);

	/**
     * checks if the the dictionary is empty
     */
    boolean isEmpty();
    
    /**
     * checks if the the dictionary has the given term or not
     */
    boolean contains(String string);
    
    /**
     * returns the posting list of a given term, if dictionary doesn't contain the term,return null
     */
    List<Integer> lookup(String string);
}
