package SearchEngine ;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;



import test.* ;

import org.hibernate.Session ;
import org.hibernate.Transaction;
import org.hibernate.ejb.criteria.expression.function.LengthFunction;

public class InvertedIndex {
	public ArrayList<PostingList> index=new ArrayList<PostingList>();
	public Dictionary Dic=new Dictionary();
	public int numberOfDoc=0; 
	public double docLength;
	
	public ArrayList<String> urls = new ArrayList<String>() ;
	public InvertedIndex() {};
	
	public void saveDicToDB (HashMap <String,Term> words)
	{
		Session session = DBController.getInstance().getSession() ;
		Transaction transaction = session.beginTransaction() ;
		for(int i=0 ; i<index.size() ; i++)
		{
			Term t = words.get(index.get(i).word);
			if(t != null)
			{
				words.remove(t.getWord());
				t.setDF(t.getDF()+1);
				session.update(t) ;
				words.put(t.getWord(), t);
			}
			else
			{
				if(index.get(i).word.length() <30)
				{
					t = new Term (index.get(i).word,1) ;
					session.save(t) ;
					words.put(index.get(i).word, t) ;
				}
			}
		}
		transaction.commit() ;
	}
	public void saveToDB(HashMap <String,Term> words,HashMap <String,Document>mydocs) throws Exception
	{
		
		saveDicToDB(words);
		UtilityOfDB dbutil = new UtilityOfDB() ;
		Document curdoc = dbutil.fetchDocument(new Document (urls.get(0)));
		Session session = DBController.getInstance().getSession() ;
		Transaction transaction = session.beginTransaction() ;
		for(int i=0 ; i<index.size() ; i++)
		{
			
			PostingList temppl = index.get(i) ;
			if(temppl.word.length() >=30)
				continue;
			Term t = words.get(temppl.word);
			DocumentTerm dt = new DocumentTerm() ;
			dt.setDoc(curdoc);
			dt.setTerm(t);
			dt.setTf(temppl.getPL().get(0).numberOfRepeats);
			session.save(dt) ;
			
		}
		
		calculateLength() ;
		curdoc.setLength(docLength);
		//alave bar tool crawled ham true mikonam
		curdoc.setCrawled(true);
		transaction.commit() ;
		
	}
	
	public void add(String word,int docID,int weight){
		Dic.add(word);
		int ptr=Dic.getIndexNumber(word);
		if(ptr>=index.size()){
			index.add(new PostingList(word));
		}
		boolean newWordDoc=(index.get(ptr)).addDoc(docID,weight);
		if(newWordDoc==true){
			Dic.setDF(word,Dic.getDF(word)+1);
		}
		
	}
	
	@Override
	public String toString() {
		String ret=new String();
		for(int i=0;i<Dic.counter;i++){
			ret=ret+index.get(i).toString()+'\n';
		}
		return ret;
	}

	public void calculateLength() {
		docLength = 0 ;
		for(int i=0;i<index.size();i++){
			ArrayList<DocTermInfo> pl = index.get(i).getPL();
			docLength=docLength+(1+Math.log(pl.get(0).numberOfRepeats))*(1+Math.log(pl.get(0).numberOfRepeats));
			
		}
		docLength=Math.sqrt(docLength);
		
	}
	
}
