package retrieval ;

import SearchEngine.InvertedIndex;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileDescriptor;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import judgement.BoolRet;
import judgement.Judge;

import retrieval.SearchEngine;
import tokenizer.MyTokenizer;

public class MySearchEngine implements SearchEngine {
	InvertedIndex invertedIndex = new InvertedIndex();
	QueryHandler queryHandler = new QueryHandler();
	public static String rootAddress = new String(
			"E:\\university\\term 7\\MIR\\Time Test Collection V2.0\\Time Test Collection");
	public static int numofReturn = 0 ;
	public static int modeofuse=0 ;
	//@Override
	public List<Integer> retrieve(String query) {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * retrieve list of related docs(by docID) for the given query by boolean
	 * retrieval method
	 */
	private List<Integer> booleanRetrieve(String query) {
		return null;
	}

	/**
	 * retrieve list of related docs(by docID) for the given query by ranked
	 * retrieval methods
	 */
	private List<Integer> rankedRetrieval(String query) {
		return null;
	}

	public static void main(String[] args) throws Exception {
		
		System.out.println("please enter the type of retrieval:");
		Scanner sc = new Scanner(System.in) ;	
		
		String typeOfRetrieval = sc.next();
		
		MySearchEngine google = new MySearchEngine();
		
		if(!typeOfRetrieval.equals("B-AND") && !typeOfRetrieval.equals("B-OR")){
			System.out.println("please enter the number of doc which should be returned for a query:");
			numofReturn = sc.nextInt();
		}
		
		System.out.println("please enter the mode of using search engine:");
		System.out.println("1. see statistical results on dataset");
		System.out.println("2.search a query");
		
		modeofuse = sc.nextInt() ;
		
		{	// build index
			File directory = new File(rootAddress + "\\Docs");
			String filename[] = directory.list();
			google.invertedIndex.numberOfDoc = filename.length;
			for (int i = 0; i < filename.length; i++) {
				String Address = directory + "\\doc" + Integer.toString(i+1);
				MyTokenizer mt = new MyTokenizer(Address,1);
				while (mt.hasMore()) {
					String s = mt.next();
					// System.err.println("------>"+s);
					google.invertedIndex.add(s, i,1);
				}
			}
		}
		google.invertedIndex.calculateLength();
		System.out.println("Index has been made");
		
		ArrayList[] relevant;
		relevant = new ArrayList[100];
		if(modeofuse == 1){
			{// read correct relevant
				System.out.println("please enter the root directory for dataset:");
				rootAddress= sc.nextLine();
				//System.out.println(google.invertedIndex);
				while(rootAddress.length()<2)
					rootAddress= sc.nextLine();
				
				File directory = new File(rootAddress + "\\Relevancy Judgments");
				String filename[] = directory.list();
				String Address = directory + "\\relevance";
				File relevantFile = new File(Address);
				Scanner relScanner = null;
				try {
					relScanner = new Scanner(relevantFile);
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				}
				for (int i = 1; i <= 83; i++) {
					relevant[i] = new ArrayList<Integer>();
					String input = relScanner.nextLine();
					if (input.equals("")) {
						i--;
						continue;
					}
					int tedad = 0;
					int bef = 0;
					input = input.trim();
					for (int j = 0; j < input.length(); j++) {
						if (input.charAt(j) == ' ') {
							if (tedad > 0 && bef != j) {
								relevant[i].add(Integer.parseInt(input.substring(
										bef, j)) - 1);
							}
							bef = j + 1;
							tedad++;
						}
					}
					if (tedad > 0 && bef != input.length()) {
						relevant[i].add(Integer.parseInt(input.substring(bef, input
								.length())) - 1);
					}
					/*	System.out.print(i + ":: ");
				for (int j = 0; j < relevant[i].size(); j++) {
					System.out.print(relevant[i].get(j) + " ");
				}
				System.out.println();*/

				}

			}
			{// answer query
				File directory = new File(rootAddress + "\\Queries");
				String filename[] = directory.list();
				ArrayList[] result;
				result = new ArrayList[100];
				double mapval=0,rprecisionval=0 ;
				int rel=0,numofdoc=0,relreturn=0 ;
				// ArrayList<Integer> result;
				for (int i = 0; i < filename.length; i++) {
					result[i] = new ArrayList<Integer>();
					String Address = directory + "\\" + filename[i];
					int index=Integer.parseInt(filename[i].substring(1));
					result[index] = google.queryHandler.Handle(typeOfRetrieval,
							Address, google.invertedIndex);
					String destAddress = new String(rootAddress + "\\Results");
					String destfileaddress = new String(typeOfRetrieval + i);
					File destFile = new File(destAddress + "\\" + destfileaddress);
					// BufferedOutputStream ol=new BufferedOutputStream(destFile.)
					PrintStream output = new PrintStream(destFile);
					/*if(i==0){
					System.out.println(Address);
					System.out.println(index + " ::: "+result[index]+" ------- "+relevant[index]);
				}*/
					double tempval ;
					tempval = Judge.map(result[index], relevant[index]) ;
					mapval =mapval+tempval ;
					output.println(tempval);

					tempval = Judge.Rprecision(result[index], relevant[index]) ;
					rprecisionval =rprecisionval+tempval ;
					output.println(tempval);

					BoolRet tempbool = new BoolRet(0,0,0) ;
					tempbool = Judge.boolEvaluate(result[index], relevant[index]);
					relreturn +=tempbool.relret;
					rel += tempbool.rel ;
					numofdoc+=tempbool.numofdoc ;
					output.println(tempbool.toString());
					output.close();
				}
				//evaluate
				int numofquery = 83 ;
				System.out.print("map : ");
				System.out.println(mapval/numofquery);
				System.out.print("R-precision: ");
				System.out.println(rprecisionval/numofquery);
				System.out.print("binary evaluation: ");
				System.out.println("BoolRet [numofdoc=" + numofdoc + ", rel=" + rel + ", relret="
						+ relreturn + "]");
				System.out.print("elevenpoint measure: ");
				System.out.println(Judge.elevenPoint(result, relevant, numofquery));


				// System.out.println(invertedIndex);
			}
		}
		else{
			System.out.println("please enter your query:");
			ArrayList<Integer> searchres = new ArrayList<Integer> () ;
			searchres =  google.queryHandler.Handle(typeOfRetrieval,
					"Stdin", google.invertedIndex);
			for(int i=0 ; i<searchres.size() ; i++)
				searchres.set(i, searchres.get(i)+1);
			System.out.println("search result: "+searchres);
		}
	}
		
}
