package retrieval;

import SearchEngine.DocTermInfo;

import SearchEngine.InvertedIndex;
import SearchEngine.PostingList;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.Set;

import javax.naming.spi.DirStateFactory.Result;

import org.hibernate.Query;
import org.hibernate.Transaction;

import tokenizer.MyTokenizer;
import test.*;
public class QueryHandler {

	InvertedIndex invertedIndex;


	public ArrayList<Document> Handle(String query){
		MyTokenizer mt = new MyTokenizer(query,0);
		HashMap<String,Double> terms=new HashMap<String, Double>();
		HashMap<Document, Double> docScore=new HashMap<Document, Double>();
		while (mt.hasMore()) {
			String temp=mt.next();
			Double value=terms.get(temp);
			if(value==null){
				terms.put(temp, new Double(1));
			}else{
				terms.remove(temp);
				terms.put(temp, value+1);
			}
		}
		ArrayList<DocumentTerm> dt=new ArrayList<DocumentTerm>();
		UtilityOfDB dbutil=new UtilityOfDB();
		for (Entry<String, Double> entry : terms.entrySet()) {
		    String key = entry.getKey();
		    Double value = entry.getValue();
		    String queryString = "from Term where word = :word";  
			Query query1 = DBController.getInstance().getSession().createQuery(queryString);  
			query1.setString("word", key);
			ArrayList<Term> chert=(ArrayList<Term>)query1.list();
			
			if(chert==null || chert.size()==0){
				continue;
			}
			Term t=chert.get(0);
		    entry.setValue(value*Math.log(2000/t.getDF()));
		}
		
		for (Entry<String, Double> entry : terms.entrySet()) {
		    String key = entry.getKey();
		    Double value = entry.getValue();
		    Term t=dbutil.fetchTerm(new Term(key,0));
		    String queryString = "from DocumentTerm where Term_ID =:term";  
			Query query1 = DBController.getInstance().getSession().createQuery(queryString);  
			query1.setParameter("term", t);
			ArrayList<DocumentTerm> dt2=(ArrayList<DocumentTerm>)query1.list();
		    dt.addAll(dt2);
		}
		
		for(int i=0;i<dt.size();i++){
			Document d=dt.get(i).getDoc();
			Double score=docScore.get(d);
			if(score==null){
				docScore.put(d,new Double(d.getPageRank()));
				score=docScore.get(d);
			}
			docScore.remove(d);
			score=score+dt.get(i).getTf()*terms.get(dt.get(i).getTerm().getWord());
			docScore.put(d, score);
		}
		ArrayList<Pair> output=new ArrayList<Pair>();
		for (Entry<Document, Double> entry : docScore.entrySet()) {
			Pair temp=new Pair(entry.getKey(), entry.getValue());
			temp.score=temp.score/entry.getKey().getLength();
			output.add(temp);
		}
		Collections.sort(output);
		ArrayList<Document> result=new ArrayList<Document>();
		for(int i=0;i<output.size();i++){
			result.add(output.get(i).doc);
		}
		return result;
	}



}
