
package test ;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import tokenizer.MyTokenizer;
import SearchEngine.InvertedIndex;

public class DocRepresentation {

	public int docnum = 0 ;
	public String title ;
	public String fehrest   ;
	public String content ;
	public String URLaddress ;
	private final int titleweight = 5 ;
	private final int fehrestweight = 2 ;
	
	
	public ArrayList <String> urls = new ArrayList <String>() ;
	public DocRepresentation(String title, String fehrest, String content,int docnumber) {
		super();
		this.title = title;
		this.fehrest = fehrest;
		this.content = content;
		this.docnum= docnumber ;
	}
	public int  saveToDB(Document mydoc,int num,HashMap<String,Document> mydocs)
	{
		UtilityOfDB dbutil = new UtilityOfDB() ;
	
		//TODO
		
		double probability = 0 ;
		if(urls.size() >0)
			probability=1.0/4.0;
		Document []doc = new Document [urls.size()] ;
		for(int i=0 ; i<urls.size(); i++)
			doc[i]= null ;
		//probability = 10.0/urls.size() ;
		Session session = DBController.getInstance().getSession() ;
		Transaction transaction = session.beginTransaction() ;
		for(int i=0 ; i<urls.size() && num <2100 ; i++)
		{
			if(Math.random() > probability || urls.get(i).length()>=100)
				continue ;
			
			//Long temp = mydocuments.get(urls.get(i));
			String queryString = "from Document where link = :link";  
			Query query = DBController.getInstance().getSession().createQuery(queryString);  
			query.setString("link", urls.get(i));
			Object queryResult = query.uniqueResult();  
			doc[i] = (Document)queryResult;
			if(doc[i] == null)
			{
				
				num++ ;
				
				doc[i]= new Document(urls.get(i));
				session.save(doc[i]) ;
				mydocs.put(doc[i].getLink(), doc[i]);
			}
		}	
		transaction.commit() ;
			
		session = DBController.getInstance().getSession() ;
		transaction = session.beginTransaction() ;
		mydoc.setTitle(title);
		mydoc.setCrawled(true);
		for(int i =0 ; i<urls.size(); i++)
		{
			if(doc[i] != null)
			{
				DocumentDocument dd = new DocumentDocument() ;
				dd.setDoc1(mydoc);
				dd.setDoc2(doc[i]);
				session.save(dd) ;
			}
			
		}
		transaction.commit() ;
		return num ;	
		
	}
	public DocRepresentation()
	{
		title = new String () ;
		fehrest = new String ();
		content = new String () ;
	}
	
	public void saveToIndex (InvertedIndex index) throws FileNotFoundException
	{
			// build index
		index.numberOfDoc = 1 ;
	//	PrintStream error =new PrintStream( new File("error2"));
	//	error.println(docnum) ;
	//	error.println(URLaddress);
		index.urls.add(URLaddress) ;
		
		MyTokenizer mt = new MyTokenizer(title,0);
		
		while (mt.hasMore()) {
			String s = mt.next();
			// System.err.println("------>"+s);
			index.add(s, docnum,titleweight);
		}

		mt = new MyTokenizer (fehrest,0);
		while (mt.hasMore()) {
			String s = mt.next();
			// System.err.println("------>"+s);
			index.add(s, docnum,fehrestweight);
		}

		mt = new MyTokenizer (content,0);
		while (mt.hasMore()) {
			String s = mt.next();
			// System.err.println("------>"+s);
			index.add(s, docnum,1);
		}
	}
	
}
