package test;

import java.awt.Color;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import retrieval.QueryHandler;

public class GUIWindow extends JFrame {
	final int startX=100,startY=100,sizeX=800,sizeY=900;
	final int margin=100;
	JButton searchButton=new JButton();
	JTextField queryText=new JTextField();
	JPanel homepage=new JPanel();
	JPanel resultpage=new JPanel();
	Link []urls=new Link[5];
	JButton prev=new JButton();
	JButton next=new JButton();
	JButton backToHomePage=new JButton();
	JLabel icon,icon2;
	int page=1;
	ArrayList<Document> docs;
	public GUIWindow() {
		super();
		for(int i=0;i<5;i++){
			urls[i]=new Link();
			urls[i].setBounds(margin, startY+10, sizeX-2*margin, sizeY/7);
			resultpage.add(urls[i]);
		}
		
		this.setLayout(null);
		this.setTitle("Google");
		this.setBounds(startX, startY, sizeX, sizeY);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		homepage.setLayout(null);
		homepage.setBounds(0,0,sizeX,sizeY);
		homepage.setBackground(Color.white);

		resultpage.setVisible(false);
		resultpage.setLayout(null);
		resultpage.setBounds(0,0,sizeX,sizeY);
		resultpage.setBackground(Color.white);
		

		//		queryText.setText("Write your query here!" );
		queryText.setBounds(margin,200,sizeX-2*margin,30);

		searchButton.setBounds(sizeX/2-sizeX/8,250, 2*sizeX/8, 30);
		searchButton.setText("Search here!");

		searchButton.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e)
			{
				//Execute when button is pressed
				QueryHandler qh=new QueryHandler();
				System.out.println(queryText.getText());
				docs= qh.Handle(queryText.getText());
				homepage.setVisible(false);
				page=1;
				resultpage.setVisible(true);
				updatepage(docs);
				repaint();
			}
		});      
		
		prev.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent arg0) {
				if(page==1){
					return;
				}
				page--;
				updatepage(docs);
				repaint();

			}
		});
		
		prev.setText("go to previous page!");
		prev.setBounds(margin,6*sizeY/7+10,200,40);
		
		next.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent arg0) {
				if(page*5>=docs.size()){
					return;
				}
				page++;
				updatepage(docs);
				repaint();
			}
		});
		
		next.setText("go to next page!");
		next.setBounds(800-200-margin,6*sizeY/7+10,200,40);
		
		backToHomePage.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent arg0) {
				resultpage.setVisible(false);
				homepage.setVisible(true);
				repaint();
			}
		});
		
		backToHomePage.setText("go back to homepage!");
		backToHomePage.setBounds(800-200-margin,40,200,40);
		
		BufferedImage myPicture=null;
		try {
			myPicture = ImageIO.read(new File("icon.png"));
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		icon= new JLabel(new ImageIcon( myPicture ));
		icon.setBounds(sizeX/2-328/2,40, 328, 127);
		
		homepage.add(searchButton);
		homepage.add(queryText);
		homepage.add(icon);
		
		icon2= new JLabel(new ImageIcon( myPicture ));
		icon2.setBounds(margin/2,0, 328, 127);
		resultpage.add(prev);
		resultpage.add(next);
		resultpage.add(backToHomePage);
		resultpage.add(icon2);
	
		this.add(homepage);
		this.add(resultpage);
		this.setVisible(true);
		this.repaint();
	}
	void updatepage(ArrayList<Document> docs){
		int startY=sizeY/7;
		int temp=(page-1)*5;
		if(docs.size()==0){
			urls[0].setText("No page found!");
			urls[0].setEnabled(false);
			urls[0].setVisible(true);
			for(int i=1;i<5;i++){
				urls[i].setVisible(false);
			}
			return;
		}
		for(int i=0;i<5;i++,temp++){
			urls[i].setVisible(false);
			if(temp<docs.size()){
				urls[i]=new Link(docs.get(temp));
				urls[i].setBounds(margin, startY+10, sizeX-2*margin, sizeY/7);
				resultpage.add(urls[i]);
				startY+=sizeY/7;
				urls[i].setEnabled(true);
				urls[i].setVisible(true);
			}
		}
	}

}