package tokenizer;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import retrieval.MySearchEngine;
import stemmer.Stemmer;
import stemmer.MyStemmer;
import tokenizer.Tokenizer;

public class MyTokenizer implements Tokenizer
{
	private Pattern mailPattern;
	private Matcher mailMatcher;
 
	private Pattern webPattern;
	private Matcher webMatcher;
	public static ArrayList<String> stopWord=new ArrayList<String>();
	String fileAddress;
	File file;
	Scanner sc;
	enum TYPE{Text,File};
	ArrayList<String> results=new ArrayList<String>();
	int p;
	
	private static final String EMAIL_PATTERN = 
		"^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*@"
		+ "[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
 
	private static final String WEBSITE_PATTERN = 
		"^(https?|ftp|file)://[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*[-a-zA-Z0-9+&@#/%=~_|]";
	
	public boolean mailValidate(final String mail) {
		mailMatcher = mailPattern.matcher(mail);
		return mailMatcher.matches();
	}
	
	
	
	public boolean webValidate(final String mail) {
		webMatcher = webPattern.matcher(mail);
		return webMatcher.matches();
	}

	public  MyTokenizer(String s , int mode) {
	
		mailPattern = Pattern.compile(EMAIL_PATTERN);
		webPattern = Pattern.compile(WEBSITE_PATTERN);
		if(stopWord.size()==0){
			File stop= new File("stopword");
			Scanner stopSC = null;
			try {
				stopSC = new Scanner(stop);
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
			}
			while(stopSC.hasNext()){
				String chert=stopSC.next();
				//	System.out.println(chert);
				
				stopWord.add(chert.toLowerCase());
			}
		}
		if(mode == 0)
		{
			sc = new Scanner(s);
		}
			
		else if(!s.equals("Stdin")){
			fileAddress=s;
			file= new File(fileAddress);
			try {
				sc=new Scanner(file);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}
		else
			sc = new Scanner(System.in);
		parse();
		p=0;
	}

	private void parse() {
		String delim ;
		delim = new String();
		delim=delim+' '; // space
		delim=delim+','; //comma
		delim=delim+'\t'; //tab
		delim=delim+';'; //semi colon
		delim=delim+'\n'; // enter
		delim=delim+'"';
		delim=delim+"!?#$%^&*()+{}<>=~`|]["; //the others
		
		String whole=new String("");
		while(sc.hasNext()){
			whole=whole+' '+sc.nextLine();
		}
		StringTokenizer st = new StringTokenizer(whole,delim);
		MyStemmer stem=new MyStemmer();
		
	    while (st.hasMoreTokens()) {
	    	ArrayList <String> temp =specialSplit(st.nextToken());
	    	for(int i=0 ; i<temp.size() ;i++){
	    		if(stopWord.contains(temp.get(i))){
	    			continue; //TODO remove to not have stop words
	    		}
	    		if(temp.get(i).length() <=2&&(temp.get(i).charAt(0)>='9'||temp.get(i).charAt(0)<='0'))
	    			continue ;
	    			
	    		results.add(stem.stem(temp.get(i)));
	    		
	    	}
	    }
	     
		
	}

	private ArrayList<String> specialSplit(String input) {
		if(input.charAt(0)=='.'){
			input=input.substring(1);
		}
		if(input.length()>=1 && input.charAt(input.length()-1)=='.'){
			input=input.substring(0,input.length()-1);
		}
		ArrayList<String> result = new ArrayList<String>() ;
		if(mailValidate(input)==true){
			result.add(input);
		}else if(webValidate(input)==true){
			result.add(input);
		}else{
			boolean hasNumber=false;
			List<Integer> mark = new ArrayList<Integer>();
			mark.add(0);
			for(int i=0;i<input.length();i++){
				if(input.charAt(i)<='9' && input.charAt(i)>='0' )
				{
					hasNumber=true;
					if(i>0)
					{
						if((input.charAt(i-1)<='z' && input.charAt(i-1)>='a')||input.charAt(i-1)<='Z' && input.charAt(i-1)>='A')
							mark.add(i);
					}

				}
				else if((input.charAt(i)<='z' && input.charAt(i)>='a')||input.charAt(i)<='Z' && input.charAt(i)>='A')
				{
					if(i>0)
					{
						if(input.charAt(i-1)<='9' && input.charAt(i-1)>='0' ){
							mark.add(i);
						}
					}
				}
			}
				mark.add(input.length());
				String delim="@_:/\\.";
				if(hasNumber==false){
					delim=delim+"-";
				}
				for(int j=0 ; j<mark.size() ;j++)
				{
					if(j==mark.size()-1)
						break ;
					StringTokenizer mailTokenizer=new StringTokenizer(input.substring(mark.get(j),mark.get(j+1)), delim);
					while(mailTokenizer.hasMoreTokens()){
						result.add(mailTokenizer.nextToken());
					}
				}
		}
		return result;
	}

	//@Override
	public boolean hasMore() {
		if(p==results.size()){
			return false;
		}
		return true;
	}

	//@Override
	public String next() {
		if(p==results.size()){
			return null;
		}
		return results.get(p++);
	}

	//@Override
	public void Tokenizer(String s) {}

	
}
